#!/usr/bin/python 
import  re,string,os,sys
from  expandEntities import expandAllEntities

if re.compile("Python\Z").search(os.getcwd()):
    os.chdir("..")

STRICT=1
TRANSITIONAL=2
FRAMESET=3

dtd=STRICT
#dtd=TRANSITIONAL
#dtd=FRAMESET

values={
    '%CAlign;':'top|bottom|left|right',
    '%IAlign;':'top|middle|bottom|left|right',
    '%LAlign;':'top|bottom|left|right',
    '%TAlign;':'left|center|right',
    '%Character;':'a single character',
    '%Charset;':'a character encoding',
    '%Charsets;':'a space-separated list of character encodings',
    '%Color;':'a color',
    '%ContentType;':'media type',
    '%ContentTypes;':'comma-separated list of media types',
    '%Coords;':'comma-separated list of lengths',
    '%Datetime;':'date and time information. ISO date format',
    '%InputType;':'text|password|checkbox|radio|submit|reset|file|hidden|image|button',
    '%LanguageCode;':'a language code',
    '%Length;':'nn for pixels or nn% for percentage length',
    '%LinkTypes;':'space-separated list of link types',
    '%MediaDesc;':'single or comma-separated list of media descriptors',
    '%MultiLength;':'pixel, percentage, or relative',
    '%MultiLengths;':'comma-separated list of pixels, percentages, or relative',
    '%Pixels;':'integer representing length in pixels',
    '%Scope;':'row|col|rowgroup|colgroup',
    '%Script;':'script expression',
    '%Shape;':'rect|circle|poly|default',
    '%Text;':'a sequence of characters from the document character set which  may include character entities',
    '%TFrame;':'void|above|below|hsides|lhs|rhs|vsides|box|border',
    '%TRules;':'none|groups|rows|cols|all',
    '%URI;':'a Uniform Resource Identifier',
    'CDATA':'a sequence of characters from the document character set which  may include character entities',
    'IDREF':'an ID defined by other attributes',
    'IDREFS':"a space-separated list of ID's defined by other attributes",
    'NUMBER':'at least one digit ([0-9])',
    'NAME':"must begin with a letter ([A-Za-z]) and may be followed by any number of letters, digits ([0-9]), hyphens ('-'), underscores ('_'), colons (':'), and periods ('.')",
    '%LIStyle;':'disc|square|circle',
    '%OLStyle;':'1|a|A|i|I',
    '%ULStyle;':'disc|square|circle',
    '%StyleSheet;':'stylesheet data',
    }

butAnchors={}

try:
    dtd= int(sys.argv[1])
except:
    pass



if dtd==STRICT:
    dtdFile='xhtml1-strict.dtd'
    dtdName='Strict'
elif dtd==TRANSITIONAL:
    dtdFile='xhtml1-transitional.dtd'
    dtdName='Transitional'
elif dtd==FRAMESET:
    dtdFile='xhtml1-frameset.dtd'
    dtdName='Frameset'


anchors={}
elementMap = {}

def extractAnchors():
    f = 'Standard/index/elements.html'
    input=open(f)
    data=input.read()
    input.close()

    xxx=re.compile('<td title="Name">\s*<a href="(.*?)">\s*(.*?)\s*</a></td>').findall(data)
    for x in xxx:
        anchors[string.lower(x[1])]=x[0][3:]
        


    f = 'Standard/index/attributes.html'
    input=open(f)
    data=input.read()
    input.close()
    xxx=re.compile('<td title="Name">(.*?)</td>\s*<td align="center" title="Related Elements">(.*?)</td>\s*<td align="center" title="Type">\s*(.*?)\s*</td>',re.S).findall(data)



    for x in xxx:
        allBut=0
        if re.compile('All elements</a> but').search(x[1]):
            allBut=1
            
        hit=re.compile('"(.*?)">\s*(.*?)\s*<',re.S).search(x[0])
        name=hit.group(2)
        anch=hit.group(1)[3:]
        val=re.compile('<a.*?>\s*').sub('',x[2])
        val=re.compile('\s*</a>').sub('',val)

        if allBut:
            butAnchors[name]=(anch,val)
        else:
            yyy=re.compile('<a.*?href\s*=\s*".*?".*?>\s*(.*?)\s*</a>',re.S).findall(x[1])
            for y in yyy:
                final_name=string.lower(y)+'_'+name
                anchors[string.lower(y)+'_'+name]=(anch,val)

class Element:
    def __init__(self,name,dtd):
        self.attributes={}
        self.name=name
        self.children = re.compile("[\w-]+").findall(dtd)
        self.children.sort()

    def printElement(self):
        print '<element name="'+self.name+ '"',
        print 'standard="'+anchors[self.name]+'"',
        print '>'

        for ch in self.children:
            if ch=='EMPTY' or ch=="XXXXXXX":
                continue
            print "<child>"+ch+"</child>"

        xxx = self.attributes.keys()
        xxx.sort()
        for a in xxx:
            self.attributes[a].printAttribute()
        print '</element>'
    

    def assignAttributes(self,data):
        data = re.compile("\(\s+").sub("(",data)
        data = re.compile("\s+\)").sub(")",data)
        data = re.compile("\s*\|\s*").sub("|",data)

        items = string.split(data)

        NAME=1
        VALUE=2
        OCCURENCE=3
        switch = NAME
        skip=0
        
        for i in items:
            if i=='#FIXED':
                skip=1
                continue
            
            if switch==NAME:
                name=string.strip(i)

                
                switch=VALUE
                
            elif switch==VALUE:
                value=string.strip(i)
                switch=OCCURENCE
                
            elif switch==OCCURENCE:
                occurence=string.strip(i)
                occurence=re.compile('"').sub("&amp;",occurence)
                switch=NAME

                if not(skip):
                    ttt=0
                    if ttt==1:
                        print name+" ::: "+value+" ::: " + occurence
                    self.attributes[name]= Attribute(self.name,name,value,occurence)

                skip=0

        ttt=0
        if ttt==1:
            print data
            sys.exit()


class Attribute:
    def __init__(self,element,name,type,occurence):
        self.element=element
        self.name=name
        self.type=type
        self.occurence=occurence

    def printAttribute(self):
        print '<attribute name="'+self.name+'"',
        print 'type="'+self.type+'"',

        try:
            print 'standard="'+anchors[self.element+'_'+self.name][0]+'"',

            val=''
            val = anchors[self.element+'_'+self.name][1]
            vvv = re.compile('\s').sub('',val)
            vvv = re.compile('\((.*?)\)').search(vvv)
            if vvv:
                val=vvv.group(1)
            else:
                val=values[string.strip(val)]
            val=re.compile('\|').sub(' | ',val)
            print 'value="'+val+'"',

        except KeyError:
            try:
                print 'standard="'+butAnchors[self.name][0]+'"',
                val=''
                val = butAnchors[self.name][1]
                vvv = re.compile('\s').sub('',val)
                vvv = re.compile('\((.*?)\)').search(vvv)
                if vvv:
                    val=vvv.group(1)
                else:
                    val=values[string.strip(val)]
                val=re.compile('\|').sub(' | ',val)
                print 'value="'+val+'"',

            except KeyError:
                pass
        
        print 'occurence="'+self.occurence+'"',
        print '/>'



def aaa(hit):

    try:
        return entities[hit.group(1)]
    except KeyError:
        return hit.group(0)



import pickle
if 1:
    inEnt = open("Data/"+dtdFile+"entities.xxx",'w')
    p = pickle.Pickler(inEnt)
    entities = expandAllEntities(dtdFile)
    p.dump(entities)
    inEnt.close()
else:
    inEnt = open("Data/"+dtdFile+"entities.xxx")
    p = pickle.Unpickler(inEnt)
    entities = p.load()
    inEnt.close()



extractAnchors()
os.chdir("dtd")
data=''


## for f in os.listdir("."):
##     if os.path.isdir(f):
##         continue

input = open(dtdFile)
data = input.read()
input.close()

os.chdir('..')

elements = re.compile("<!ELEMENT\s+(\S+)\s+(.*?)\s*>",re.S).findall(data)
attributes = re.compile("<!ATTLIST\s+(.*?)\s*>",re.S).findall(data)


for e in elements:
    xxx=re.compile("%(\S+?);").sub(aaa,e[0])
    yyy = re.compile("%(\S+?);").sub(aaa,e[1])
    if xxx[0:1]=='%':
        continue
    elementMap[xxx] = Element(xxx,yyy)


for a in attributes:
    xxx = re.compile("%(\S+?);").sub(aaa,a)

    if xxx[0:1]=='%':
        continue
    hit = re.compile("(\S+?)\s+(.*)",re.S).match(xxx)
    
    elementMap[hit.group(1)].assignAttributes(hit.group(2))
            

emap = elementMap.keys()
emap.sort()

output = open("Data/"+dtdName+".xml",'w')
sys.stdout = output
    
print """
 <!-- generated by run.py  -->\n
 <!DOCTYPE xhtmlReference [
 <!ENTITY comparison SYSTEM 'comparison.xml'>
 <!ENTITY examples SYSTEM 'examples.xml'>
 ]>
"""

print "<xhtmlReference>"
for ename in emap:
    elementMap[ename].printElement()
    
print "&comparison;"
print "&examples;"
print "</xhtmlReference>"

output.close()


if 0:
    pass
else:
    xml = "Data/"+dtdName+".xml"
    html = "Output/index.html"
    os.system("saxonclient -o "+html+" "+xml+" XSLT/stylesheet.xslt dtdName="+dtdName+" pwd=${PWD}/")






